import random
import math
random.seed("basic01/multitasking")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([3, 4, 3, 1, 2], 1)
        self.print_test([6, 2, 5, 1], 2)

    def generate_min_tests(self):
        self.print_test([1], 1)
        self.print_test([2], 3)
        self.print_test([2, 3], 2)
        self.print_test([4, 3], 2)
        self.print_test([100, 3, 5], 3)

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxv):
        n = maxn
        a = []
        for i in range(n):
            a.append(random.randint(1, maxv))
        if random.randint(1, 2) == 1:
            b = random.randint(1, int(math.sqrt(max(a))))
        else:
            b = random.randint(1, min(maxv, max(a) + 1))
        self.print_test(a, b)

    def generate_max_tests(self, maxn, maxv):
        self.print_test([maxv] * maxn, 1)
        self.print_test([maxv] * maxn, maxv)
        self.print_test([maxv] * maxn, int(math.sqrt(maxv)))
        self.print_test([maxv] * maxn, 2)
        a = [maxv] * maxn
        for i in range(int(math.sqrt(maxn))):
            index = random.randint(0, len(a) - 1)
            a[index] -= random.randint(2, 5)
        self.print_test(a, 1)
        self.print_test(a, 2)

    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), b, file=test_file)
        print(' '.join(map(str, a)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [10, 50, 100, 10**3, 10**4, 10**5]
        maxvs = [5, 10, 100, 10**4, 10**6, 10**9]
        for n in ns:
            for maxv in maxvs:
                self.generate_random_test(n, maxv)
        self.generate_max_tests(10**5, 10**9)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
