#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

const int MAXX = 100;
int cur_test = -1;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int a, int b, int c, int d) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    if ((a + b + c + d) % 2 != 0)
        a = (a % MAXX) + 1;
    printf("%d %d %d %d\n", a, b, c, d);
}

void gen_rand(int maxn)
{
    int a = rnd.next(maxn) + 1;
    int b = rnd.next(maxn) + 1;
    int c = rnd.next(maxn) + 1;
    int d = rnd.next(maxn) + 1;
    write_test(a, b, c, d);    
}

void gen_special(int maxn)
{
    int a = rnd.next(maxn) + 1;
    int b = rnd.next(maxn) + 1;
    int c = rnd.next(maxn) + 1;
    int d = b;
    write_test(a, b, c, d);    
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);

    for (int i = 10; i <= MAXX; i += 10)     
    {
        gen_rand(i);
        gen_rand(i);
        gen_special(i);
    }
    write_test(MAXX, MAXX, MAXX, MAXX);
    write_test(MAXX, MAXX / 2, MAXX / 2, MAXX);
    write_test(MAXX / 2, 1, 1, MAXX);
    return 0;
}