#include "testlib.h"
#include <string>
#include <vector>
#include <sstream>
#include <iostream>

using namespace std;

int n, m;
const int MAXN = 501;
int used[MAXN][MAXN];
string s1[MAXN], s2[MAXN], s3[MAXN];
int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

bool check(int x, int y)
{
    return x >= 0 && x < n && y >= 0 && y < m && s2[x][y] == '*' && used[x][y] == 0;
}

void dfs(int x, int y)
{
    used[x][y] = 1;
    for (int i = 0; i < 4; i++)
    {
        if (check(x + dx[i], y + dy[i]))
            dfs(x + dx[i], y + dy[i]);
    }
}

int main(int argc, char * argv[])
{
    //setName("compare files as sequence of lines");
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    m = inf.readInt();
    int c3 = 0, c2 = 0;
    s1[0] = inf.readString();
    for (int i = 0; i < n; i++)
    {
        s1[i] = inf.readString();
        s2[i] = ouf.readString();
        s3[i] = ans.readString();
        /*
        for (int j = 0; j < s1[i].size(); j++)
            cout << s1[i][j];
        cout << "!";
        for (int j = 0; j < s2[i].size(); j++)
            cout << s2[i][j];
        cout << "!";
        for (int j = 0; j < s3[i].size(); j++)
            cout << s3[i][j];
        cout << "!  ";
        cout << endl;
        //*/
        if (s2[i].size() != m)
            quitf(_wa, "Line %d contains not %d characters", i + 1, m);
        int c1 = 0;
        for (int j = 0; j < m; j++)
        {
            if (s1[i][j] == '*' && s2[i][j] == '.')
                quitf(_wa, "The area doesn't contain a tower on the cell (%d, %d)", i + 1, j + 1);
            if (s2[i][j] == '*' && c1 > 0 && s2[i][j - 1] == '.')
                quitf(_wa, "The area is not convex");
            if (s2[i][j] == '*')
            {
                c1++;
                c2++;
            }
            if (s3[i][j] == '*')
                c3++;
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (s2[i][j] == '*' && used[i][j] == 0)
            {
                dfs(i, j);
                cnt++;
            }
        }
    }
    if (cnt > 1)
        quitf(_wa, "The area is not connected");
    for (int j = 0; j < m; j++)
    {
        int c1 = 0;
        for (int i = 0; i < n; i++)
        {
            if (s2[i][j] == '*' && c1 > 0 && s2[i - 1][j] == '.')
                quitf(_wa, "The area is not convex");
            if (s2[i][j] == '*')
                c1++;
        }
    }
    if (c2 > c3)
        quitf(_wa, "The area is not minimum");
    if (c2 < c3)
        quitf(_fail, "The participant has a better answer than the jury");
    quitf(_ok, "");
}
